<?php
/**
 * Neuron - DuckBrain
 *
 * Neuron, sirve para crear un objeto que alojará valores, pero
 * además tiene la característica especial de que al intentar
 * acceder a un atributo que no está definido devolerá nulo en
 * lugar de generar un error php notice que indica que se está
 * intentando acceder a un valor no definido.
 *
 * El constructor recibe un objeto o arreglo con los valores que
 * sí estarán definidos.
 *
 * @author KJ
 * @website https://kj2.me
 * @licence MIT
 */

namespace Libs;

class Neuron {
    public function __construct(array|object $data = []) {
        foreach($data as $key => $value)
            $this->{$key} = $value;
    }

    public function __get(string $index) {
        return (isset($this->{$index}) &&
                $this->{$index} != '') ? $this->{$index} : null;
    }
}

?>
